 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for korient
   >>>> 
   >>>>    Written By: Donna Koechner, Mark Young & Ashish Malhotra
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Apr 08, 1995
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _korient_h_
#define _korient_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include "kdatamanip/kdatamanip.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$DATAMANIP/objects/kroutine/korient/uis/korient.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input data object (required infile)
 */
char	*i_file;	/* input data object FILENAME */
int	 i_flag;	/* input data object FLAG */

/*
 *  resulting data object (required outfile)
 */
char	*o_file;	/* resulting data object FILENAME */
int	 o_flag;	/* resulting data object FLAG */

/*----- required ME group ----*/
/*
 *  orient WIDTH data to be on WIDTH dimension (optional flag)
 */
int	 ww_flag;  	/* orient WIDTH data to be on WIDTH dimension FLAG */

/*
 *  orient WIDTH data to be on HEIGHT dimension (optional flag)
 */
int	 wh_flag;  	/* orient WIDTH data to be on HEIGHT dimension FLAG */

/*
 *  orient WIDTH data to be on ELEMENTS dimension (optional flag)
 */
int	 we_flag;  	/* orient WIDTH data to be on ELEMENTS dimension FLAG */

/*
 *  orient WIDTH data to be on DEPTH dimension (optional flag)
 */
int	 wd_flag;  	/* orient WIDTH data to be on DEPTH dimension FLAG */

/*
 *  orient WIDTH data to be on TIME dimension (optional flag)
 */
int	 wt_flag;  	/* orient WIDTH data to be on TIME dimension FLAG */

/*-- required ME group end ---*/

/*----- required ME group ----*/
/*
 *  orient HEIGHT data to be on WIDTH dimension (optional flag)
 */
int	 hw_flag;  	/* orient HEIGHT data to be on WIDTH dimension FLAG */

/*
 *  orient HEIGHT data to be on HEIGHT dimension (optional flag)
 */
int	 hh_flag;  	/* orient HEIGHT data to be on HEIGHT dimension FLAG */

/*
 *  orient HEIGHT data to be on ELEMENTS dimension (optional flag)
 */
int	 he_flag;  	/* orient HEIGHT data to be on ELEMENTS dimension FLAG */

/*
 *  orient HEIGHT data to be on DEPTH dimension (optional flag)
 */
int	 hd_flag;  	/* orient HEIGHT data to be on DEPTH dimension FLAG */

/*
 *  orient HEIGHT data to be on TIME dimension (optional flag)
 */
int	 ht_flag;  	/* orient HEIGHT data to be on TIME dimension FLAG */

/*-- required ME group end ---*/

/*----- required ME group ----*/
/*
 *  orient ELEMENT data to be on WIDTH dimension (optional flag)
 */
int	 ew_flag;  	/* orient ELEMENT data to be on WIDTH dimension FLAG */

/*
 *  orient ELEMENT data to be on HEIGHT dimension (optional flag)
 */
int	 eh_flag;  	/* orient ELEMENT data to be on HEIGHT dimension FLAG */

/*
 *  orient ELEMENT data to be on ELEMENTS dimension (optional flag)
 */
int	 ee_flag;  	/* orient ELEMENT data to be on ELEMENTS dimension FLAG */

/*
 *  orient ELEMENT data to be on DEPTH dimension (optional flag)
 */
int	 ed_flag;  	/* orient ELEMENT data to be on DEPTH dimension FLAG */

/*
 *  orient ELEMENT data to be on TIME dimension (optional flag)
 */
int	 et_flag;  	/* orient ELEMENT data to be on TIME dimension FLAG */

/*-- required ME group end ---*/

/*----- required ME group ----*/
/*
 *  orient DEPTH data to be on WIDTH dimension (optional flag)
 */
int	 dw_flag;  	/* orient DEPTH data to be on WIDTH dimension FLAG */

/*
 *  orient DEPTH data to be on HEIGHT dimension (optional flag)
 */
int	 dh_flag;  	/* orient DEPTH data to be on HEIGHT dimension FLAG */

/*
 *  orient DEPTH data to be on ELEMENTS dimension (optional flag)
 */
int	 de_flag;  	/* orient DEPTH data to be on ELEMENTS dimension FLAG */

/*
 *  orient DEPTH data to be on DEPTH dimension (optional flag)
 */
int	 dd_flag;  	/* orient DEPTH data to be on DEPTH dimension FLAG */

/*
 *  orient DEPTH data to be on TIME dimension (optional flag)
 */
int	 dt_flag;  	/* orient DEPTH data to be on TIME dimension FLAG */

/*-- required ME group end ---*/

/*----- required ME group ----*/
/*
 *  orient TIME data to be on WIDTH dimension (optional flag)
 */
int	 tw_flag;  	/* orient TIME data to be on WIDTH dimension FLAG */

/*
 *  orient TIME data to be on HEIGHT dimension (optional flag)
 */
int	 th_flag;  	/* orient TIME data to be on HEIGHT dimension FLAG */

/*
 *  orient TIME data to be on ELEMENTS dimension (optional flag)
 */
int	 te_flag;  	/* orient TIME data to be on ELEMENTS dimension FLAG */

/*
 *  orient TIME data to be on DEPTH dimension (optional flag)
 */
int	 td_flag;  	/* orient TIME data to be on DEPTH dimension FLAG */

/*
 *  orient TIME data to be on TIME dimension (optional flag)
 */
int	 tt_flag;  	/* orient TIME data to be on TIME dimension FLAG */

/*-- required ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **, char **));
void korient_get_args PROTO((kform *));
void korient_usage_additions PROTO((void));
void korient_free_args PROTO((int, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
