 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ggencmap.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ggencmap_get_args
| 
|       Purpose: Gets command line args for ggencmap
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ggencmap
|          Date: Apr 13, 1995
| Modifications: 
| 
------------------------------------------------------------*/
void ggencmap_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for ggencmap is out of sync with arguments specified in ggencmap's *.pane file; please rerun ghostwriter on ggencmap.";


	/*
	 * allocate the ggencmap structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((unsigned)1, (unsigned) sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "minval",
			  &(clui_info->minval_float),
			  &(clui_info->minval_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "maxval",
			  &(clui_info->maxval_float),
			  &(clui_info->maxval_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "outf",
			  &(clui_info->outf_file),
			  &(clui_info->outf_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "use_hsv",
			  &(clui_info->use_hsv_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "hs",
			  &(clui_info->hs_float),
			  &(clui_info->hs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "he",
			  &(clui_info->he_float),
			  &(clui_info->he_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ss",
			  &(clui_info->ss_float),
			  &(clui_info->ss_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "se",
			  &(clui_info->se_float),
			  &(clui_info->se_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "vs",
			  &(clui_info->vs_float),
			  &(clui_info->vs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ve",
			  &(clui_info->ve_float),
			  &(clui_info->ve_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "use_rgb",
			  &(clui_info->use_rgb_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "rs",
			  &(clui_info->rs_float),
			  &(clui_info->rs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "re",
			  &(clui_info->re_float),
			  &(clui_info->re_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "gs",
			  &(clui_info->gs_float),
			  &(clui_info->gs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ge",
			  &(clui_info->ge_float),
			  &(clui_info->ge_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "bs",
			  &(clui_info->bs_float),
			  &(clui_info->bs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "be",
			  &(clui_info->be_float),
			  &(clui_info->be_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "use_alpha",
			  &(clui_info->use_alpha_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "as",
			  &(clui_info->as_float),
			  &(clui_info->as_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ae",
			  &(clui_info->ae_float),
			  &(clui_info->ae_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



